package base

import pb "sghgogs.com/micro/shopping-service-service/proto"

func IsStatusEnum(enum pb.StatusEnum) bool {
	switch enum {
	case pb.StatusEnum_ENABLED:
		return true
	case pb.StatusEnum_DISABLED:
		return true
	case pb.StatusEnum_DELETED:
		return true
	}
	return false
}

func IsValidOrderStatus(status pb.OrderStatusEnum) bool {
	switch status {
	case pb.OrderStatusEnum_ORDER_UNKNOWN,
		pb.OrderStatusEnum_ORDER_CREATED,
		pb.OrderStatusEnum_ORDER_PENDING_PAYMENT,
		pb.OrderStatusEnum_ORDER_PAID,
		pb.OrderStatusEnum_ORDER_PROCESSING,
		pb.OrderStatusEnum_ORDER_SHIPPED,
		pb.OrderStatusEnum_ORDER_COMPLETED,
		pb.OrderStatusEnum_ORDER_CANCELED,
		pb.OrderStatusEnum_ORDER_REFUND_IN_PROGRESS,
		pb.OrderStatusEnum_ORDER_REFUNDED,
		pb.OrderStatusEnum_ORDER_RETURNED,
		pb.OrderStatusEnum_UNDER_REVIEW,
		pb.OrderStatusEnum_ORDER_DELIVERING:
		return true
	default:
		return false
	}
}

func IsValidPaymentMethod(enum pb.PaymentMethodEnum) bool {
	switch enum {
	case pb.PaymentMethodEnum_PAYMENT_METHOD_UNKNOWN, pb.PaymentMethodEnum_ALIPAY, pb.PaymentMethodEnum_WECHAT_PAY, pb.PaymentMethodEnum_BANK_ACCOUNT, pb.PaymentMethodEnum_CREDIT_CARD, pb.PaymentMethodEnum_VIRTUAL_WALLET, pb.PaymentMethodEnum_OFFLINE_PAYMENT:
		return true
	default:
		return false
	}
}

func IsValidRefundRequestStatus(enum pb.RefundRequestStatusEnum) bool {
	switch enum {
	case pb.RefundRequestStatusEnum_REFUND_REQUEST_STATUS_PENDING, pb.RefundRequestStatusEnum_REFUND_REQUEST_STATUS_PROCESSING, pb.RefundRequestStatusEnum_REFUND_REQUEST_STATUS_PROCESSED, pb.RefundRequestStatusEnum_REFUND_REQUEST_STATUS_REJECTED:
		return true
	default:
		return false
	}
}
