package request

import "time"

type Location struct {
	ID        int64      `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	AddressID int64      `gorm:"not null" json:"address_id"`
	Lon       float32    `json:"lon"` // 经度（Longitude）
	Lat       float32    `json:"lat"` // 纬度（Latitude）
	CreatedAt time.Time  `json:"created_at"`
	UpdatedAt *time.Time `json:"updated_at"`
}

type Address struct {
	ID          int64      `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	UserID      int64      `gorm:"not null" json:"user_id"`
	Name        string     `json:"name"`                                 // 收货人姓名
	PhoneNumber string     `json:"phone_number"`                         // 手机号
	CountryCode string     `json:"country_code"`                         // 国家
	ProvinceID  string     `json:"province_id"`                          // 省 ID
	CityID      string     `json:"city_id"`                              // 城市ID
	DistrictID  string     `json:"district_id"`                          // 区ID
	StreetID    string     `json:"street_id"`                            // 街道 ID
	VillagesID  string     `json:"villages_id"`                          // 居委会
	Remark      string     `json:"remark"`                               // 详细地址
	Location    *Location  `gorm:"foreignKey:AddressID" json:"location"` // 地理位置
	IsDefault   int32      `json:"is_default"`                           // 默认地址 0/家 | 1/其他
	CreatedAt   time.Time  `json:"created_at"`
	UpdatedAt   *time.Time `json:"updated_at"`
}
