package request

import "time"

type Courier struct {
	ID          int64      `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	Name        string     `json:"name"`
	Password    string     `json:"-" gorm:"unique_index;not_null"` // 这里使用 "-" 表示在 JSON 输出时不包含密码字段
	PhoneNumber string     `json:"phone_number"`
	Email       string     `json:"email"`
	Avatar      string     `json:"avatar"`
	Status      string     `json:"status"` // 配送员状态，例如"空闲"、"忙碌"	、"休息"等
	CreatedAt   time.Time  `json:"created_at"`
	UpdatedAt   *time.Time `json:"updated_at"`
}
