package request

import "time"

type Delivery struct {
	ID           int64      `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	OrderID      int64      `gorm:"not_null" json:"order_id"`   // 关联的订单ID
	CourierID    int64      `gorm:"not_null" json:"courier_id"` // 配送员ID
	DeliveryTime *time.Time `json:"delivery_time"`              // 配送时间
	Status       string     `json:"status"`                     // 配送状态，例如"配送中"、"已完成"等
	DeliveryNote string     `json:"delivery_note"`              // 配送备注
	CreatedAt    time.Time  `json:"created_at"`
	UpdatedAt    *time.Time `json:"updated_at"`
}
