package request

import (
	pb "sghgogs.com/micro/shopping-service-service/proto"
	"time"
)

type Permission struct {
	ID          int64         `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	Name        string        `json:"name"`
	Endpoint    string        `json:"endpoint"`
	Description string        `json:"description"`
	Roles       []Role        `gorm:"many2many:role_permission;" json:"roles"`
	CreatedAt   time.Time     `json:"created_at"`
	CreatedBy   string        `json:"created_by"`
	UpdatedAt   *time.Time    `json:"updated_at"`
	UpdatedBy   string        `json:"updated_by"`
	Status      pb.StatusEnum `json:"status"` // 可以是 "enabled", "disabled", "deleted" 等
	IsReserved  bool          `json:"is_reserved"`
}
