package request

import "time"

// Product 商品表模型
type Product struct {
	ID            int64      `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	Name          string     `json:"name"`           // 商品名称
	Description   string     `json:"description"`    // 商品描述
	Price         int64      `json:"price"`          // 商品价格
	StockQuantity int32      `json:"stock_quantity"` // 库存数量
	CreatedAt     time.Time  `json:"created_at"`
	CreatedBy     string     `json:"created_by"`
	UpdatedAt     *time.Time `json:"updated_at"`
	UpdatedBy     string     `json:"updated_by"`
	CategoryID    int64      `json:"category_id"`
	Category      *Category  `gorm:"foreignKey:CategoryID" json:"category"`
	ImageURL      string     `json:"image_url"`
}

// Image 图片表模型
type Image struct {
	ID        int64      `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	URL       string     `json:"url"` // 图片 URL
	ProductID int64      `json:"product_id"`
	CreatedAt time.Time  `json:"created_at"`
	UpdatedAt *time.Time `json:"updated_at"`
}
