package request

import (
	pb "sghgogs.com/micro/shopping-service-service/proto"
	"time"
)

// RefundRequest 退款申请表模型
type RefundRequest struct {
	ID        int64                      `gorm:"primaryKey;autoIncrement" json:"id"`
	UserID    int64                      `json:"user_id"`
	OrderID   int64                      `json:"order_id"`
	Reason    string                     `json:"reason"`
	Status    pb.RefundRequestStatusEnum `json:"status"` // 退款申请状态，如待处理、处理中、已完成等
	CreatedAt time.Time                  `json:"created_at"`
	UpdatedAt *time.Time                 `json:"updated_at"`
	// 其他字段...
}

// RefundRecord 退款记录表模型
type RefundRecord struct {
	ID           int64                     `gorm:"primaryKey;autoIncrement" json:"id"`
	OrderID      int64                     `json:"order_id"`
	Amount       int64                     `json:"amount"`
	Status       pb.RefundRecordStatusEnum `json:"status"`        // 退款状态，如成功、失败等
	RefundMethod pb.PaymentMethodEnum      `json:"refund_method"` // 退款方式，如原路退还、退款到余额等
	RefundTime   *time.Time                `json:"refund_time"`   // 退款时间
	CreatedAt    time.Time                 `json:"created_at"`
	UpdatedAt    *time.Time                `json:"updated_at"`
	// 其他字段...
}
