package request

import (
	pb "sghgogs.com/micro/shopping-service-service/proto"
	"time"
)

type Role struct {
	ID          int64         `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	Name        string        `json:"name"`
	Description string        `json:"description"`
	Users       []User        `gorm:"many2many:user_role;" json:"users"`
	Permissions []Permission  `gorm:"many2many:role_permission;" json:"permissions"`
	CreatedBy   string        `json:"created_by"`
	CreatedAt   time.Time     `json:"created_at"`
	UpdatedAt   *time.Time    `json:"updated_at"`
	UpdatedBy   string        `json:"updated_by"`
	Status      pb.StatusEnum `json:"status"` // 可以是 "enabled", "disabled", "deleted" 等
	IsReserved  bool          `json:"is_reserved"`
}
