package request

import "time"

// ShoppingCart 购物车表模型
type ShoppingCart struct {
	ID        int64              `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	UserID    int64              `gorm:"not null" json:"user_id"`
	CreatedAt time.Time          `json:"created_at"`
	UpdatedAt *time.Time         `json:"updated_at"`
	Quantity  int64              `json:"quantity"` // 商品数量
	Items     []ShoppingCartItem `gorm:"foreignKey:ShoppingCartID" json:"items"`
}
type ShoppingCartItem struct {
	ID             int64      `gorm:"primary_key;not_null;auto_increment;" json:"id"`
	ShoppingCartID int64      `gorm:"not null" json:"shopping_cart_id"`
	ProductID      int64      `gorm:"not null" json:"product_id"`
	Product        Product    `gorm:"foreignKey:ProductID" json:"product"`
	Quantity       int32      `gorm:"not null" json:"quantity"` // 商品数量
	TotalPrice     int64      `gorm:"default:0" json:"total_price"`
	CreatedAt      time.Time  `json:"created_at"`
	UpdatedAt      *time.Time `json:"updated_at"`
}

// type ShoppingCartReqItem struct {
// 	ShoppingCartId int64              `json:"shopping_cart_id"`
// 	Items          []ShoppingCartItem `json:"items"`
// }
