package repository

import (
	req "sghgogs.com/micro/shopping-service-service/domain/model/request"
	pb "sghgogs.com/micro/shopping-service-service/proto"
)

func (u *Repository) Login(username string) (req.User, error) {
	var user req.User
	return user, u.db.Where("username = ?", username).
		Preload("Roles", "status =?", pb.StatusEnum_ENABLED).
		First(&user).Error
}

func (u *Repository) Profile(userID int64) (req.User, error) {
	db := u.db
	var user req.User
	if err := db.
		Select("id, username, phone_number, email, avatar, created_at, status").
		Preload("Roles", "status = ?", pb.StatusEnum_ENABLED).
		Preload("ShoppingCart").
		First(&user, userID).Error; err != nil {
		return req.User{}, err
	}

	return user, nil
}
