package repository

import req "sghgogs.com/micro/shopping-service-service/domain/model/request"

func (u *Repository) CreatePayment(payment *req.Payment) error {
	// 开始事务
	tx := u.db.Begin()
	// 错误处理
	defer func() {
		if r := recover(); r != nil {
			tx.Rollback()
		}
	}()
	if err := tx.Create(&payment).Error; err != nil {
		tx.Rollback()
		return err
	}
	return tx.Commit().Error
}
