package admin_user

import (
	"context"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
)

type AdminUser struct {
	Service service.IService
}

func (svc *AdminUser) GetAdminUserList(ctx context.Context, query *pb.GetAdminUserListRequest, rsp *pb.GetAdminUserListResponse) error {
	if list, i, err := svc.Service.GetAdminUserList(query); err != nil {
		return err
	} else {
		rsp.TotalCount = i
		rsp.Items = list
	}
	return nil
}

func (svc *AdminUser) GetAllAdminUser(ctx context.Context, request *pb.GetAllAdminUserRequest, rsp *pb.GetAllAdminUserResponse) error {
	if base, err := svc.Service.GetAllAdminUser(); err != nil {
		return err
	} else {
		rsp.Items = base
	}
	return nil
}

func (svc *AdminUser) GetAdminUser(ctx context.Context, query *pb.GetAdminUserRequest, rsp *pb.GetAdminUserResponse) error {
	if user, err := svc.Service.GetAdminUser(query); err != nil {
		return err
	} else {
		rsp.Data = user
	}
	return nil
}

func (svc *AdminUser) CreateAdminUser(ctx context.Context, data *pb.CreateAdminUserRequest, rsp *pb.CreateAdminUserResponse) error {
	if err := svc.Service.CreateAdminUser(ctx, data); err != nil {
		return err
	}
	return nil
}

func (svc *AdminUser) UpdateAdminUser(ctx context.Context, data *pb.UpdateAdminUserRequest, rsp *pb.UpdateAdminUserResponse) error {
	if err := svc.Service.UpdateAdminUser(ctx, data); err != nil {
		return err
	}
	return nil
}

func (svc *AdminUser) DeleteAdminUser(ctx context.Context, data *pb.DeleteAdminUserRequest, rsp *pb.DeleteAdminUserResponse) error {
	if err := svc.Service.DeleteAdminUser(data); err != nil {
		return err
	}
	return nil
}

func (svc *AdminUser) ToggleAdminUser(ctx context.Context, data *pb.ToggleAdminUserRequest, rsp *pb.ToggleAdminUserResponse) error {
	if err := svc.Service.ToggleAdminUser(ctx, data); err != nil {
		return err
	}
	return nil
}
