package category

import (
	"context"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
)

type Category struct {
	Service service.IService
}

func (svc *Category) GetCategoryList(ctx context.Context, query *pb.GetCategoryListRequest, rsp *pb.GetCategoryListResponse) error {
	if list, i, err := svc.Service.GetCategoryList(query); err != nil {
		return err
	} else {
		rsp.Items = list
		rsp.TotalCount = i
	}
	return nil
}

func (svc *Category) GetAllCategories(ctx context.Context, query *pb.GetAllCategoriesRequest, rsp *pb.GetAllCategoriesResponse) error {
	if categories, err := svc.Service.GetAllCategories(); err != nil {
		return err
	} else {
		rsp.Items = categories
	}
	return nil
}

func (svc *Category) CreateCategory(ctx context.Context, add *pb.CreateCategoryRequest, rsp *pb.CreateCategoryResponse) error {
	if err := svc.Service.CreateCategory(add); err != nil {
		return err
	}
	return nil
}

func (svc *Category) CreateMultipleCategories(ctx context.Context, add *pb.CreateMultipleCategoriesRequest, rsp *pb.CreateMultipleCategoriesResponse) error {
	if err := svc.Service.CreateMultipleCategories(add); err != nil {
		return err
	}
	return nil
}

func (svc *Category) DeleteCategory(ctx context.Context, query *pb.DeleteCategoryRequest, rsp *pb.DeleteCategoryResponse) error {
	if err := svc.Service.DeleteCategory(query); err != nil {
		return err
	}
	return nil
}
