package permission

import (
	"context"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
)

type Permission struct {
	Service service.IService
}

func (svc *Permission) GetPermissionList(ctx context.Context, query *pb.GetPermissionListRequest, rsp *pb.GetPermissionListResponse) error {
	list, i, err := svc.Service.GetPermissionList(query)
	if err != nil {
		return nil
	}
	rsp.Items = list
	rsp.TotalCount = i
	return nil
}

func (svc *Permission) GetPermission(ctx context.Context, query *pb.GetPermissionRequest, rsp *pb.GetPermissionResponse) error {
	if permission, err := svc.Service.GetPermission(query); err != nil {
		return err
	} else {
		rsp.Data = permission
	}
	return nil
}

func (svc *Permission) CreatePermission(ctx context.Context, add *pb.CreatePermissionRequest, rsp *pb.CreatePermissionResponse) error {
	if err := svc.Service.CreatePermission(ctx, add); err != nil {
		return err
	}
	return nil
}

func (svc *Permission) CreateMultiplePermissions(ctx context.Context, adds *pb.CreateMultiplePermissionsRequest, rsp *pb.CreateMultiplePermissionsResponse) error {
	if err := svc.Service.CreateMultiplePermissions(ctx, adds); err != nil {
		return err
	}
	return nil
}

func (svc *Permission) UpdatePermission(ctx context.Context, query *pb.UpdatePermissionRequest, rsp *pb.UpdatePermissionResponse) error {
	if err := svc.Service.UpdatePermission(ctx, query); err != nil {
		return err
	}
	return nil
}

func (svc *Permission) DeletePermission(ctx context.Context, query *pb.DeletePermissionRequest, rsp *pb.DeletePermissionResponse) error {
	if err := svc.Service.DeletePermission(query); err != nil {
		return err
	}
	return nil
}

func (svc *Permission) TogglePermission(ctx context.Context, query *pb.TogglePermissionRequest, rsp *pb.TogglePermissionResponse) error {
	if err := svc.Service.TogglePermission(query); err != nil {
		return err
	}
	return nil
}
