package role

import (
	"context"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
)

type Role struct {
	Service service.IService
}

func (svc *Role) GetAllRoles(ctx context.Context, query *pb.GetAllRolesRequest, rsp *pb.GetAllRolesResponse) error {
	if roles, err := svc.Service.GetAllRoles(); err != nil {
		return err
	} else {
		rsp.Items = roles
	}
	return nil
}

func (svc *Role) GetRoleList(ctx context.Context, query *pb.GetRoleListRequest, rsp *pb.GetRoleListResponse) error {
	list, i, err := svc.Service.GetRoleList(query)
	if err != nil {
		return err
	}
	rsp.TotalCount = i
	rsp.Items = list
	return nil
}

func (svc *Role) GetRole(ctx context.Context, query *pb.GetRoleRequest, rsp *pb.GetRoleResponse) error {
	role, err := svc.Service.GetRole(query)
	if err != nil {
		return err
	}
	rsp.Data = role
	return nil
}

func (svc *Role) CreateRole(ctx context.Context, query *pb.CreateRoleRequest, rsp *pb.CreateRoleResponse) error {
	if err := svc.Service.CreateRole(ctx, query); err != nil {
		return err
	}
	return nil
}

func (svc *Role) UpdateRole(ctx context.Context, query *pb.UpdateRoleRequest, rsp *pb.UpdateRoleResponse) error {
	if err := svc.Service.UpdateRole(ctx, query); err != nil {
		return err
	}
	return nil
}

func (svc *Role) DeleteRole(ctx context.Context, query *pb.DeleteRoleRequest, rsp *pb.DeleteRoleResponse) error {
	if err := svc.Service.DeleteRole(query); err != nil {
		return err
	}
	return nil
}

func (svc *Role) ToggleRole(ctx context.Context, query *pb.ToggleRoleRequest, rsp *pb.ToggleRoleResponse) error {
	if err := svc.Service.ToggleRole(ctx, query); err != nil {
		return err
	}
	return nil
}
