package user

import (
	"context"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
)

type User struct {
	Service service.IService
}

func (svc *User) GetUserList(ctx context.Context, query *pb.GetUserListRequest, rsp *pb.GetUserListResponse) error {
	list, i, err := svc.Service.GetUserList(query)
	if err != nil {
		return nil
	} else {
		rsp.TotalCount = i
		rsp.Items = list
	}
	return nil
}

func (svc *User) GetUser(ctx context.Context, query *pb.GetUserRequest, rsp *pb.GetUserResponse) error {
	if user, err := svc.Service.GetUser(query); err != nil {
		return err
	} else {
		rsp.Data = user
	}
	return nil
}

func (svc *User) CreateUser(ctx context.Context, data *pb.CreateUserRequest, rsp *pb.CreateUserResponse) error {
	if err := svc.Service.CreateUser(ctx, data); err != nil {
		return err
	}
	return nil
}

func (svc *User) UpdateUser(ctx context.Context, data *pb.UpdateUserRequest, rsp *pb.UpdateUserResponse) error {
	if err := svc.Service.UpdateUser(ctx, data); err != nil {
		return err
	}
	return nil
}

func (svc *User) DeleteUser(ctx context.Context, data *pb.DeleteUserRequest, rsp *pb.DeleteUserResponse) error {
	if err := svc.Service.DeleteUser(data); err != nil {
		return err
	}
	return nil
}

func (svc *User) ToggleUser(ctx context.Context, data *pb.ToggleUserRequest, rsp *pb.ToggleUserResponse) error {
	if err := svc.Service.ToggleUser(ctx, data); err != nil {
		return err
	}
	return nil
}
