// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/shopping_address_service.proto

package shopping_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ShoppingAddressService service

func NewShoppingAddressServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingAddressService service

type ShoppingAddressService interface {
	GetAddressListByUserID(ctx context.Context, in *GetAddressListByUserIDRequest, opts ...client.CallOption) (*GetAddressListByUserIDResponse, error)
	GetAddressByUserID(ctx context.Context, in *GetAddressByUserIDRequest, opts ...client.CallOption) (*GetAddressByUserIDResponse, error)
	CreateAddressByUserID(ctx context.Context, in *CreateAddressByUserIDRequest, opts ...client.CallOption) (*CreateAddressByUserIDResponse, error)
	UpdateAddressByUserID(ctx context.Context, in *UpdateAddressByUserIDRequest, opts ...client.CallOption) (*UpdateAddressByUserIDResponse, error)
	DeleteAddressByUserID(ctx context.Context, in *DeleteAddressByUserIDRequest, opts ...client.CallOption) (*DeleteAddressByUserIDResponse, error)
}

type shoppingAddressService struct {
	c    client.Client
	name string
}

func NewShoppingAddressService(name string, c client.Client) ShoppingAddressService {
	return &shoppingAddressService{
		c:    c,
		name: name,
	}
}

func (c *shoppingAddressService) GetAddressListByUserID(ctx context.Context, in *GetAddressListByUserIDRequest, opts ...client.CallOption) (*GetAddressListByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.GetAddressListByUserID", in)
	out := new(GetAddressListByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) GetAddressByUserID(ctx context.Context, in *GetAddressByUserIDRequest, opts ...client.CallOption) (*GetAddressByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.GetAddressByUserID", in)
	out := new(GetAddressByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) CreateAddressByUserID(ctx context.Context, in *CreateAddressByUserIDRequest, opts ...client.CallOption) (*CreateAddressByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.CreateAddressByUserID", in)
	out := new(CreateAddressByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) UpdateAddressByUserID(ctx context.Context, in *UpdateAddressByUserIDRequest, opts ...client.CallOption) (*UpdateAddressByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.UpdateAddressByUserID", in)
	out := new(UpdateAddressByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingAddressService) DeleteAddressByUserID(ctx context.Context, in *DeleteAddressByUserIDRequest, opts ...client.CallOption) (*DeleteAddressByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingAddressService.DeleteAddressByUserID", in)
	out := new(DeleteAddressByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingAddressService service

type ShoppingAddressServiceHandler interface {
	GetAddressListByUserID(context.Context, *GetAddressListByUserIDRequest, *GetAddressListByUserIDResponse) error
	GetAddressByUserID(context.Context, *GetAddressByUserIDRequest, *GetAddressByUserIDResponse) error
	CreateAddressByUserID(context.Context, *CreateAddressByUserIDRequest, *CreateAddressByUserIDResponse) error
	UpdateAddressByUserID(context.Context, *UpdateAddressByUserIDRequest, *UpdateAddressByUserIDResponse) error
	DeleteAddressByUserID(context.Context, *DeleteAddressByUserIDRequest, *DeleteAddressByUserIDResponse) error
}

func RegisterShoppingAddressServiceHandler(s server.Server, hdlr ShoppingAddressServiceHandler, opts ...server.HandlerOption) error {
	type shoppingAddressService interface {
		GetAddressListByUserID(ctx context.Context, in *GetAddressListByUserIDRequest, out *GetAddressListByUserIDResponse) error
		GetAddressByUserID(ctx context.Context, in *GetAddressByUserIDRequest, out *GetAddressByUserIDResponse) error
		CreateAddressByUserID(ctx context.Context, in *CreateAddressByUserIDRequest, out *CreateAddressByUserIDResponse) error
		UpdateAddressByUserID(ctx context.Context, in *UpdateAddressByUserIDRequest, out *UpdateAddressByUserIDResponse) error
		DeleteAddressByUserID(ctx context.Context, in *DeleteAddressByUserIDRequest, out *DeleteAddressByUserIDResponse) error
	}
	type ShoppingAddressService struct {
		shoppingAddressService
	}
	h := &shoppingAddressServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingAddressService{h}, opts...))
}

type shoppingAddressServiceHandler struct {
	ShoppingAddressServiceHandler
}

func (h *shoppingAddressServiceHandler) GetAddressListByUserID(ctx context.Context, in *GetAddressListByUserIDRequest, out *GetAddressListByUserIDResponse) error {
	return h.ShoppingAddressServiceHandler.GetAddressListByUserID(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) GetAddressByUserID(ctx context.Context, in *GetAddressByUserIDRequest, out *GetAddressByUserIDResponse) error {
	return h.ShoppingAddressServiceHandler.GetAddressByUserID(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) CreateAddressByUserID(ctx context.Context, in *CreateAddressByUserIDRequest, out *CreateAddressByUserIDResponse) error {
	return h.ShoppingAddressServiceHandler.CreateAddressByUserID(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) UpdateAddressByUserID(ctx context.Context, in *UpdateAddressByUserIDRequest, out *UpdateAddressByUserIDResponse) error {
	return h.ShoppingAddressServiceHandler.UpdateAddressByUserID(ctx, in, out)
}

func (h *shoppingAddressServiceHandler) DeleteAddressByUserID(ctx context.Context, in *DeleteAddressByUserIDRequest, out *DeleteAddressByUserIDResponse) error {
	return h.ShoppingAddressServiceHandler.DeleteAddressByUserID(ctx, in, out)
}
