// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/shopping_order_service.proto

package shopping_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ShoppingOrderService service

func NewShoppingOrderServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingOrderService service

type ShoppingOrderService interface {
	// -------------------- service --------------------------
	//
	//	rpc ApproveOrder(ApproveOrderRequest) returns(ApproveOrderResponse); // 审批订单
	ConfirmOrderProcessing(ctx context.Context, in *ConfirmOrderProcessingRequest, opts ...client.CallOption) (*ConfirmOrderProcessingResponse, error)
	InitiateShipping(ctx context.Context, in *InitiateShippingRequest, opts ...client.CallOption) (*InitiateShippingResponse, error)
	GetOrderList(ctx context.Context, in *GetOrderListRequest, opts ...client.CallOption) (*GetOrderListResponse, error)
	GetOrder(ctx context.Context, in *GetOrderRequest, opts ...client.CallOption) (*GetOrderResponse, error)
	CompleteDelivery(ctx context.Context, in *CompleteDeliveryRequest, opts ...client.CallOption) (*CompleteDeliveryResponse, error)
	// -------------------- client --------------------------
	CreateOrderByUserID(ctx context.Context, in *CreateOrderByUserIDRequest, opts ...client.CallOption) (*CreateOrderByUserIDResponse, error)
	GetOrderListByUserID(ctx context.Context, in *GetOrderListByUserIDRequest, opts ...client.CallOption) (*GetOrderListByUserIDResponse, error)
	ApplyRefund(ctx context.Context, in *ApplyRefundRequest, opts ...client.CallOption) (*ApplyRefundResponse, error)
	CancelOrderByUserIDAndOrderID(ctx context.Context, in *CancelOrderByUserIDAndOrderIDRequest, opts ...client.CallOption) (*CancelOrderByUserIDAndOrderIDResponse, error)
	GetOrderItemsByUserIDAndOrderID(ctx context.Context, in *GetOrderItemsByUserIDAndOrderIDRequest, opts ...client.CallOption) (*GetOrderItemsByUserIDAndOrderIDResponse, error)
	UpdateOrderAddressByUserIDAndOrderID(ctx context.Context, in *UpdateOrderAddressByUserIDAndOrderIDRequest, opts ...client.CallOption) (*UpdateOrderAddressByUserIDAndOrderIDResponse, error)
}

type shoppingOrderService struct {
	c    client.Client
	name string
}

func NewShoppingOrderService(name string, c client.Client) ShoppingOrderService {
	return &shoppingOrderService{
		c:    c,
		name: name,
	}
}

func (c *shoppingOrderService) ConfirmOrderProcessing(ctx context.Context, in *ConfirmOrderProcessingRequest, opts ...client.CallOption) (*ConfirmOrderProcessingResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.ConfirmOrderProcessing", in)
	out := new(ConfirmOrderProcessingResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) InitiateShipping(ctx context.Context, in *InitiateShippingRequest, opts ...client.CallOption) (*InitiateShippingResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.InitiateShipping", in)
	out := new(InitiateShippingResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) GetOrderList(ctx context.Context, in *GetOrderListRequest, opts ...client.CallOption) (*GetOrderListResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.GetOrderList", in)
	out := new(GetOrderListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) GetOrder(ctx context.Context, in *GetOrderRequest, opts ...client.CallOption) (*GetOrderResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.GetOrder", in)
	out := new(GetOrderResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) CompleteDelivery(ctx context.Context, in *CompleteDeliveryRequest, opts ...client.CallOption) (*CompleteDeliveryResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.CompleteDelivery", in)
	out := new(CompleteDeliveryResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) CreateOrderByUserID(ctx context.Context, in *CreateOrderByUserIDRequest, opts ...client.CallOption) (*CreateOrderByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.CreateOrderByUserID", in)
	out := new(CreateOrderByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) GetOrderListByUserID(ctx context.Context, in *GetOrderListByUserIDRequest, opts ...client.CallOption) (*GetOrderListByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.GetOrderListByUserID", in)
	out := new(GetOrderListByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) ApplyRefund(ctx context.Context, in *ApplyRefundRequest, opts ...client.CallOption) (*ApplyRefundResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.ApplyRefund", in)
	out := new(ApplyRefundResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) CancelOrderByUserIDAndOrderID(ctx context.Context, in *CancelOrderByUserIDAndOrderIDRequest, opts ...client.CallOption) (*CancelOrderByUserIDAndOrderIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.CancelOrderByUserIDAndOrderID", in)
	out := new(CancelOrderByUserIDAndOrderIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) GetOrderItemsByUserIDAndOrderID(ctx context.Context, in *GetOrderItemsByUserIDAndOrderIDRequest, opts ...client.CallOption) (*GetOrderItemsByUserIDAndOrderIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.GetOrderItemsByUserIDAndOrderID", in)
	out := new(GetOrderItemsByUserIDAndOrderIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingOrderService) UpdateOrderAddressByUserIDAndOrderID(ctx context.Context, in *UpdateOrderAddressByUserIDAndOrderIDRequest, opts ...client.CallOption) (*UpdateOrderAddressByUserIDAndOrderIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingOrderService.UpdateOrderAddressByUserIDAndOrderID", in)
	out := new(UpdateOrderAddressByUserIDAndOrderIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingOrderService service

type ShoppingOrderServiceHandler interface {
	// -------------------- service --------------------------
	//
	//	rpc ApproveOrder(ApproveOrderRequest) returns(ApproveOrderResponse); // 审批订单
	ConfirmOrderProcessing(context.Context, *ConfirmOrderProcessingRequest, *ConfirmOrderProcessingResponse) error
	InitiateShipping(context.Context, *InitiateShippingRequest, *InitiateShippingResponse) error
	GetOrderList(context.Context, *GetOrderListRequest, *GetOrderListResponse) error
	GetOrder(context.Context, *GetOrderRequest, *GetOrderResponse) error
	CompleteDelivery(context.Context, *CompleteDeliveryRequest, *CompleteDeliveryResponse) error
	// -------------------- client --------------------------
	CreateOrderByUserID(context.Context, *CreateOrderByUserIDRequest, *CreateOrderByUserIDResponse) error
	GetOrderListByUserID(context.Context, *GetOrderListByUserIDRequest, *GetOrderListByUserIDResponse) error
	ApplyRefund(context.Context, *ApplyRefundRequest, *ApplyRefundResponse) error
	CancelOrderByUserIDAndOrderID(context.Context, *CancelOrderByUserIDAndOrderIDRequest, *CancelOrderByUserIDAndOrderIDResponse) error
	GetOrderItemsByUserIDAndOrderID(context.Context, *GetOrderItemsByUserIDAndOrderIDRequest, *GetOrderItemsByUserIDAndOrderIDResponse) error
	UpdateOrderAddressByUserIDAndOrderID(context.Context, *UpdateOrderAddressByUserIDAndOrderIDRequest, *UpdateOrderAddressByUserIDAndOrderIDResponse) error
}

func RegisterShoppingOrderServiceHandler(s server.Server, hdlr ShoppingOrderServiceHandler, opts ...server.HandlerOption) error {
	type shoppingOrderService interface {
		ConfirmOrderProcessing(ctx context.Context, in *ConfirmOrderProcessingRequest, out *ConfirmOrderProcessingResponse) error
		InitiateShipping(ctx context.Context, in *InitiateShippingRequest, out *InitiateShippingResponse) error
		GetOrderList(ctx context.Context, in *GetOrderListRequest, out *GetOrderListResponse) error
		GetOrder(ctx context.Context, in *GetOrderRequest, out *GetOrderResponse) error
		CompleteDelivery(ctx context.Context, in *CompleteDeliveryRequest, out *CompleteDeliveryResponse) error
		CreateOrderByUserID(ctx context.Context, in *CreateOrderByUserIDRequest, out *CreateOrderByUserIDResponse) error
		GetOrderListByUserID(ctx context.Context, in *GetOrderListByUserIDRequest, out *GetOrderListByUserIDResponse) error
		ApplyRefund(ctx context.Context, in *ApplyRefundRequest, out *ApplyRefundResponse) error
		CancelOrderByUserIDAndOrderID(ctx context.Context, in *CancelOrderByUserIDAndOrderIDRequest, out *CancelOrderByUserIDAndOrderIDResponse) error
		GetOrderItemsByUserIDAndOrderID(ctx context.Context, in *GetOrderItemsByUserIDAndOrderIDRequest, out *GetOrderItemsByUserIDAndOrderIDResponse) error
		UpdateOrderAddressByUserIDAndOrderID(ctx context.Context, in *UpdateOrderAddressByUserIDAndOrderIDRequest, out *UpdateOrderAddressByUserIDAndOrderIDResponse) error
	}
	type ShoppingOrderService struct {
		shoppingOrderService
	}
	h := &shoppingOrderServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingOrderService{h}, opts...))
}

type shoppingOrderServiceHandler struct {
	ShoppingOrderServiceHandler
}

func (h *shoppingOrderServiceHandler) ConfirmOrderProcessing(ctx context.Context, in *ConfirmOrderProcessingRequest, out *ConfirmOrderProcessingResponse) error {
	return h.ShoppingOrderServiceHandler.ConfirmOrderProcessing(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) InitiateShipping(ctx context.Context, in *InitiateShippingRequest, out *InitiateShippingResponse) error {
	return h.ShoppingOrderServiceHandler.InitiateShipping(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) GetOrderList(ctx context.Context, in *GetOrderListRequest, out *GetOrderListResponse) error {
	return h.ShoppingOrderServiceHandler.GetOrderList(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) GetOrder(ctx context.Context, in *GetOrderRequest, out *GetOrderResponse) error {
	return h.ShoppingOrderServiceHandler.GetOrder(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) CompleteDelivery(ctx context.Context, in *CompleteDeliveryRequest, out *CompleteDeliveryResponse) error {
	return h.ShoppingOrderServiceHandler.CompleteDelivery(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) CreateOrderByUserID(ctx context.Context, in *CreateOrderByUserIDRequest, out *CreateOrderByUserIDResponse) error {
	return h.ShoppingOrderServiceHandler.CreateOrderByUserID(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) GetOrderListByUserID(ctx context.Context, in *GetOrderListByUserIDRequest, out *GetOrderListByUserIDResponse) error {
	return h.ShoppingOrderServiceHandler.GetOrderListByUserID(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) ApplyRefund(ctx context.Context, in *ApplyRefundRequest, out *ApplyRefundResponse) error {
	return h.ShoppingOrderServiceHandler.ApplyRefund(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) CancelOrderByUserIDAndOrderID(ctx context.Context, in *CancelOrderByUserIDAndOrderIDRequest, out *CancelOrderByUserIDAndOrderIDResponse) error {
	return h.ShoppingOrderServiceHandler.CancelOrderByUserIDAndOrderID(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) GetOrderItemsByUserIDAndOrderID(ctx context.Context, in *GetOrderItemsByUserIDAndOrderIDRequest, out *GetOrderItemsByUserIDAndOrderIDResponse) error {
	return h.ShoppingOrderServiceHandler.GetOrderItemsByUserIDAndOrderID(ctx, in, out)
}

func (h *shoppingOrderServiceHandler) UpdateOrderAddressByUserIDAndOrderID(ctx context.Context, in *UpdateOrderAddressByUserIDAndOrderIDRequest, out *UpdateOrderAddressByUserIDAndOrderIDResponse) error {
	return h.ShoppingOrderServiceHandler.UpdateOrderAddressByUserIDAndOrderID(ctx, in, out)
}
