// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/shopping_permission_service.proto

package shopping_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ShoppingPermissionService service

func NewShoppingPermissionServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingPermissionService service

type ShoppingPermissionService interface {
	GetPermissionList(ctx context.Context, in *GetPermissionListRequest, opts ...client.CallOption) (*GetPermissionListResponse, error)
	GetPermission(ctx context.Context, in *GetPermissionRequest, opts ...client.CallOption) (*GetPermissionResponse, error)
	CreatePermission(ctx context.Context, in *CreatePermissionRequest, opts ...client.CallOption) (*CreatePermissionResponse, error)
	CreateMultiplePermissions(ctx context.Context, in *CreateMultiplePermissionsRequest, opts ...client.CallOption) (*CreateMultiplePermissionsResponse, error)
	UpdatePermission(ctx context.Context, in *UpdatePermissionRequest, opts ...client.CallOption) (*UpdatePermissionResponse, error)
	DeletePermission(ctx context.Context, in *DeletePermissionRequest, opts ...client.CallOption) (*DeletePermissionResponse, error)
	TogglePermission(ctx context.Context, in *TogglePermissionRequest, opts ...client.CallOption) (*TogglePermissionResponse, error)
}

type shoppingPermissionService struct {
	c    client.Client
	name string
}

func NewShoppingPermissionService(name string, c client.Client) ShoppingPermissionService {
	return &shoppingPermissionService{
		c:    c,
		name: name,
	}
}

func (c *shoppingPermissionService) GetPermissionList(ctx context.Context, in *GetPermissionListRequest, opts ...client.CallOption) (*GetPermissionListResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingPermissionService.GetPermissionList", in)
	out := new(GetPermissionListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingPermissionService) GetPermission(ctx context.Context, in *GetPermissionRequest, opts ...client.CallOption) (*GetPermissionResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingPermissionService.GetPermission", in)
	out := new(GetPermissionResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingPermissionService) CreatePermission(ctx context.Context, in *CreatePermissionRequest, opts ...client.CallOption) (*CreatePermissionResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingPermissionService.CreatePermission", in)
	out := new(CreatePermissionResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingPermissionService) CreateMultiplePermissions(ctx context.Context, in *CreateMultiplePermissionsRequest, opts ...client.CallOption) (*CreateMultiplePermissionsResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingPermissionService.CreateMultiplePermissions", in)
	out := new(CreateMultiplePermissionsResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingPermissionService) UpdatePermission(ctx context.Context, in *UpdatePermissionRequest, opts ...client.CallOption) (*UpdatePermissionResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingPermissionService.UpdatePermission", in)
	out := new(UpdatePermissionResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingPermissionService) DeletePermission(ctx context.Context, in *DeletePermissionRequest, opts ...client.CallOption) (*DeletePermissionResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingPermissionService.DeletePermission", in)
	out := new(DeletePermissionResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingPermissionService) TogglePermission(ctx context.Context, in *TogglePermissionRequest, opts ...client.CallOption) (*TogglePermissionResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingPermissionService.TogglePermission", in)
	out := new(TogglePermissionResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingPermissionService service

type ShoppingPermissionServiceHandler interface {
	GetPermissionList(context.Context, *GetPermissionListRequest, *GetPermissionListResponse) error
	GetPermission(context.Context, *GetPermissionRequest, *GetPermissionResponse) error
	CreatePermission(context.Context, *CreatePermissionRequest, *CreatePermissionResponse) error
	CreateMultiplePermissions(context.Context, *CreateMultiplePermissionsRequest, *CreateMultiplePermissionsResponse) error
	UpdatePermission(context.Context, *UpdatePermissionRequest, *UpdatePermissionResponse) error
	DeletePermission(context.Context, *DeletePermissionRequest, *DeletePermissionResponse) error
	TogglePermission(context.Context, *TogglePermissionRequest, *TogglePermissionResponse) error
}

func RegisterShoppingPermissionServiceHandler(s server.Server, hdlr ShoppingPermissionServiceHandler, opts ...server.HandlerOption) error {
	type shoppingPermissionService interface {
		GetPermissionList(ctx context.Context, in *GetPermissionListRequest, out *GetPermissionListResponse) error
		GetPermission(ctx context.Context, in *GetPermissionRequest, out *GetPermissionResponse) error
		CreatePermission(ctx context.Context, in *CreatePermissionRequest, out *CreatePermissionResponse) error
		CreateMultiplePermissions(ctx context.Context, in *CreateMultiplePermissionsRequest, out *CreateMultiplePermissionsResponse) error
		UpdatePermission(ctx context.Context, in *UpdatePermissionRequest, out *UpdatePermissionResponse) error
		DeletePermission(ctx context.Context, in *DeletePermissionRequest, out *DeletePermissionResponse) error
		TogglePermission(ctx context.Context, in *TogglePermissionRequest, out *TogglePermissionResponse) error
	}
	type ShoppingPermissionService struct {
		shoppingPermissionService
	}
	h := &shoppingPermissionServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingPermissionService{h}, opts...))
}

type shoppingPermissionServiceHandler struct {
	ShoppingPermissionServiceHandler
}

func (h *shoppingPermissionServiceHandler) GetPermissionList(ctx context.Context, in *GetPermissionListRequest, out *GetPermissionListResponse) error {
	return h.ShoppingPermissionServiceHandler.GetPermissionList(ctx, in, out)
}

func (h *shoppingPermissionServiceHandler) GetPermission(ctx context.Context, in *GetPermissionRequest, out *GetPermissionResponse) error {
	return h.ShoppingPermissionServiceHandler.GetPermission(ctx, in, out)
}

func (h *shoppingPermissionServiceHandler) CreatePermission(ctx context.Context, in *CreatePermissionRequest, out *CreatePermissionResponse) error {
	return h.ShoppingPermissionServiceHandler.CreatePermission(ctx, in, out)
}

func (h *shoppingPermissionServiceHandler) CreateMultiplePermissions(ctx context.Context, in *CreateMultiplePermissionsRequest, out *CreateMultiplePermissionsResponse) error {
	return h.ShoppingPermissionServiceHandler.CreateMultiplePermissions(ctx, in, out)
}

func (h *shoppingPermissionServiceHandler) UpdatePermission(ctx context.Context, in *UpdatePermissionRequest, out *UpdatePermissionResponse) error {
	return h.ShoppingPermissionServiceHandler.UpdatePermission(ctx, in, out)
}

func (h *shoppingPermissionServiceHandler) DeletePermission(ctx context.Context, in *DeletePermissionRequest, out *DeletePermissionResponse) error {
	return h.ShoppingPermissionServiceHandler.DeletePermission(ctx, in, out)
}

func (h *shoppingPermissionServiceHandler) TogglePermission(ctx context.Context, in *TogglePermissionRequest, out *TogglePermissionResponse) error {
	return h.ShoppingPermissionServiceHandler.TogglePermission(ctx, in, out)
}
