// Code generated by protoc-gen-micro. DO NOT EDIT.
// source: proto/shopping_refund_service.proto

package shopping_service

import (
	fmt "fmt"
	proto "google.golang.org/protobuf/proto"
	math "math"
)

import (
	context "context"
	api "go-micro.dev/v4/api"
	client "go-micro.dev/v4/client"
	server "go-micro.dev/v4/server"
)

// Reference imports to suppress errors if they are not otherwise used.
var _ = proto.Marshal
var _ = fmt.Errorf
var _ = math.Inf

// Reference imports to suppress errors if they are not otherwise used.
var _ api.Endpoint
var _ context.Context
var _ client.Option
var _ server.Option

// Api Endpoints for ShoppingRefundService service

func NewShoppingRefundServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingRefundService service

type ShoppingRefundService interface {
	// -------------------- service --------------------------
	GetRefundRequestList(ctx context.Context, in *GetRefundRequestListRequest, opts ...client.CallOption) (*GetRefundRequestListResponse, error)
	ApproveRefund(ctx context.Context, in *ApproveRefundRequest, opts ...client.CallOption) (*ApproveRefundResponse, error)
	CompleteRefund(ctx context.Context, in *CompleteRefundRequest, opts ...client.CallOption) (*CompleteRefundResponse, error)
	// -------------------- client --------------------------
	ApplyForRefundByUserID(ctx context.Context, in *ApplyForRefundByUserIDRequest, opts ...client.CallOption) (*ApplyForRefundByUserIDResponse, error)
}

type shoppingRefundService struct {
	c    client.Client
	name string
}

func NewShoppingRefundService(name string, c client.Client) ShoppingRefundService {
	return &shoppingRefundService{
		c:    c,
		name: name,
	}
}

func (c *shoppingRefundService) GetRefundRequestList(ctx context.Context, in *GetRefundRequestListRequest, opts ...client.CallOption) (*GetRefundRequestListResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingRefundService.GetRefundRequestList", in)
	out := new(GetRefundRequestListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingRefundService) ApproveRefund(ctx context.Context, in *ApproveRefundRequest, opts ...client.CallOption) (*ApproveRefundResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingRefundService.ApproveRefund", in)
	out := new(ApproveRefundResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingRefundService) CompleteRefund(ctx context.Context, in *CompleteRefundRequest, opts ...client.CallOption) (*CompleteRefundResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingRefundService.CompleteRefund", in)
	out := new(CompleteRefundResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

func (c *shoppingRefundService) ApplyForRefundByUserID(ctx context.Context, in *ApplyForRefundByUserIDRequest, opts ...client.CallOption) (*ApplyForRefundByUserIDResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingRefundService.ApplyForRefundByUserID", in)
	out := new(ApplyForRefundByUserIDResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingRefundService service

type ShoppingRefundServiceHandler interface {
	// -------------------- service --------------------------
	GetRefundRequestList(context.Context, *GetRefundRequestListRequest, *GetRefundRequestListResponse) error
	ApproveRefund(context.Context, *ApproveRefundRequest, *ApproveRefundResponse) error
	CompleteRefund(context.Context, *CompleteRefundRequest, *CompleteRefundResponse) error
	// -------------------- client --------------------------
	ApplyForRefundByUserID(context.Context, *ApplyForRefundByUserIDRequest, *ApplyForRefundByUserIDResponse) error
}

func RegisterShoppingRefundServiceHandler(s server.Server, hdlr ShoppingRefundServiceHandler, opts ...server.HandlerOption) error {
	type shoppingRefundService interface {
		GetRefundRequestList(ctx context.Context, in *GetRefundRequestListRequest, out *GetRefundRequestListResponse) error
		ApproveRefund(ctx context.Context, in *ApproveRefundRequest, out *ApproveRefundResponse) error
		CompleteRefund(ctx context.Context, in *CompleteRefundRequest, out *CompleteRefundResponse) error
		ApplyForRefundByUserID(ctx context.Context, in *ApplyForRefundByUserIDRequest, out *ApplyForRefundByUserIDResponse) error
	}
	type ShoppingRefundService struct {
		shoppingRefundService
	}
	h := &shoppingRefundServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingRefundService{h}, opts...))
}

type shoppingRefundServiceHandler struct {
	ShoppingRefundServiceHandler
}

func (h *shoppingRefundServiceHandler) GetRefundRequestList(ctx context.Context, in *GetRefundRequestListRequest, out *GetRefundRequestListResponse) error {
	return h.ShoppingRefundServiceHandler.GetRefundRequestList(ctx, in, out)
}

func (h *shoppingRefundServiceHandler) ApproveRefund(ctx context.Context, in *ApproveRefundRequest, out *ApproveRefundResponse) error {
	return h.ShoppingRefundServiceHandler.ApproveRefund(ctx, in, out)
}

func (h *shoppingRefundServiceHandler) CompleteRefund(ctx context.Context, in *CompleteRefundRequest, out *CompleteRefundResponse) error {
	return h.ShoppingRefundServiceHandler.CompleteRefund(ctx, in, out)
}

func (h *shoppingRefundServiceHandler) ApplyForRefundByUserID(ctx context.Context, in *ApplyForRefundByUserIDRequest, out *ApplyForRefundByUserIDResponse) error {
	return h.ShoppingRefundServiceHandler.ApplyForRefundByUserID(ctx, in, out)
}

// Api Endpoints for ShoppingRefundRecordService service

func NewShoppingRefundRecordServiceEndpoints() []*api.Endpoint {
	return []*api.Endpoint{}
}

// Client API for ShoppingRefundRecordService service

type ShoppingRefundRecordService interface {
	// -------------------- service --------------------------
	GetRefundRecordList(ctx context.Context, in *GetRefundRecordListRequest, opts ...client.CallOption) (*GetRefundRecordListResponse, error)
}

type shoppingRefundRecordService struct {
	c    client.Client
	name string
}

func NewShoppingRefundRecordService(name string, c client.Client) ShoppingRefundRecordService {
	return &shoppingRefundRecordService{
		c:    c,
		name: name,
	}
}

func (c *shoppingRefundRecordService) GetRefundRecordList(ctx context.Context, in *GetRefundRecordListRequest, opts ...client.CallOption) (*GetRefundRecordListResponse, error) {
	req := c.c.NewRequest(c.name, "ShoppingRefundRecordService.GetRefundRecordList", in)
	out := new(GetRefundRecordListResponse)
	err := c.c.Call(ctx, req, out, opts...)
	if err != nil {
		return nil, err
	}
	return out, nil
}

// Server API for ShoppingRefundRecordService service

type ShoppingRefundRecordServiceHandler interface {
	// -------------------- service --------------------------
	GetRefundRecordList(context.Context, *GetRefundRecordListRequest, *GetRefundRecordListResponse) error
}

func RegisterShoppingRefundRecordServiceHandler(s server.Server, hdlr ShoppingRefundRecordServiceHandler, opts ...server.HandlerOption) error {
	type shoppingRefundRecordService interface {
		GetRefundRecordList(ctx context.Context, in *GetRefundRecordListRequest, out *GetRefundRecordListResponse) error
	}
	type ShoppingRefundRecordService struct {
		shoppingRefundRecordService
	}
	h := &shoppingRefundRecordServiceHandler{hdlr}
	return s.Handle(s.NewHandler(&ShoppingRefundRecordService{h}, opts...))
}

type shoppingRefundRecordServiceHandler struct {
	ShoppingRefundRecordServiceHandler
}

func (h *shoppingRefundRecordServiceHandler) GetRefundRecordList(ctx context.Context, in *GetRefundRecordListRequest, out *GetRefundRecordListResponse) error {
	return h.ShoppingRefundRecordServiceHandler.GetRefundRecordList(ctx, in, out)
}
