package payment

import (
	"fmt"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
	"gorm.io/gorm/logger"
	"gorm.io/gorm/schema"
	"sghgogs.com/micro/shopping-service-service/domain/repository"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
	"testing"
)

func TestPayment(t *testing.T) {
	address := fmt.Sprintf("%v:%v@(%v:%v)/%v?charset=utf8mb4,utf8&parseTime=True&loc=Local", "root", "xugang131500", "47.56.16.206", 3306, "shopping_wenke")
	db, err := gorm.Open(mysql.Open(address), &gorm.Config{
		Logger: logger.Default.LogMode(logger.Info),
		NamingStrategy: schema.NamingStrategy{
			SingularTable: true,
		}})
	if err != nil {
		t.Fatal(err)
	}
	repo := repository.NewRepository(db)
	newService := service.NewService(repo, "shoppingservice")
	t.Run("创建", func(t *testing.T) {
		err2 := newService.CreatePayment(&pb.CreatePaymentRequest{
			OrderId:       1,
			Amount:        1200,
			Status:        pb.PaymentStatusEnum_PAYMENT_PENDING,
			PaymentMethod: pb.PaymentMethodEnum_PAYMENT_METHOD_BANKCARD,
		})
		fmt.Println(err2)
	})
	// service.NewService(repo, "shoppingservice")
}
