package shoppingcart

import (
	"fmt"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
	"gorm.io/gorm/logger"
	"gorm.io/gorm/schema"
	req "sghgogs.com/micro/shopping-service-service/domain/model/request"
	"sghgogs.com/micro/shopping-service-service/domain/repository"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
	"testing"
)

func TestShoppingCart(t *testing.T) {
	address := fmt.Sprintf("%v:%v@(%v:%v)/%v?charset=utf8mb4,utf8&parseTime=True&loc=Local", "root", "xugang131500", "47.56.16.206", 3306, "shopping_wenke")
	db, err := gorm.Open(mysql.Open(address), &gorm.Config{
		Logger: logger.Default.LogMode(logger.Info),
		NamingStrategy: schema.NamingStrategy{
			SingularTable: true,
		}})
	if err != nil {
		t.Fatal(err)
	}
	repo := repository.NewRepository(db)
	newService := service.NewService(repo, "shoppingservice")
	// ?service.NewService(repo, "shoppingservice")
	t.Run("创建", func(t *testing.T) {
		err2 := newService.CreateShoppingCart(&pb.CreateShoppingCartRequest{UserId: 2, Quantity: 0})
		fmt.Println(err2)
	})
	t.Run("更新或者创建", func(t *testing.T) {
		err2 := newService.AddToShoppingCart(&pb.AddToCartRequest{
			UserId:    1,
			ProductId: 2,
			Quantity:  1,
		})
		fmt.Println(err2)
	})
	t.Run("查询购物车", func(t *testing.T) {
		// shoppingCart, err3 := newService.GetShoppingCart(&pb.GetClientShoppingCartRequest{UserId: 1})
		// fmt.Println(shoppingCart)
		// fmt.Println(err3)
		var count int64
		db.Model(&req.ShoppingCartItem{}).Where("shopping_cart_id = ?", 1).Count(&count)
		fmt.Println(count)
		// var user req.User
		// items := make([]req.ShoppingCartItem, 0)
		// if err := db.Model(&req.User{}).Preload("ShoppingCart").First(&user, userID).Error; err != nil {
		// 	return items, err
		// }
		// if user.ShoppingCart.ID == 0 {
		// 	return items, nil
		// }
		// var shoppingCartItems []req.ShoppingCartItem
		// if err := u.db.Model(&req.ShoppingCartItem{}).Preload("Product").Where("shopping_cart_id = ?", user.ShoppingCart.ID).Find(&shoppingCartItems).Error; err != nil {
		// 	if errors.Is(err, gorm.ErrRecordNotFound) {
		// 		return items, nil
		// 	} else {
		// 		return items, err
		// 	}
		// }
		// var res req.User
		// db.Model(&req.User{}).Preload("ShoppingCart").First(&res, 3)
		// fmt.Println(res.ShoppingCart.ID)
		// var res req.ShoppingCartItem
		// db.Model(&req.ShoppingCartItem{}).Where("shopping_cart_id = ?", 4).First(&res)
		// fmt.Println(res.ID)
		cart, err2 := newService.GetShoppingCart(&pb.GetClientShoppingCartRequest{UserId: 1})
		fmt.Println(cart)
		fmt.Println(err2)
		// user, err2 := newService.GetUser(&pb.GetUserRequest{
		// 	UserId: 1,
		// })
		// fmt.Println(err2)
		// fmt.Println(user)
	})
}
