package shoppingcart

import (
	"fmt"
	"gorm.io/driver/mysql"
	"gorm.io/gorm"
	"gorm.io/gorm/logger"
	"gorm.io/gorm/schema"
	"sghgogs.com/micro/shopping-service-service/domain/repository"
	"sghgogs.com/micro/shopping-service-service/domain/service"
	pb "sghgogs.com/micro/shopping-service-service/proto"
	"testing"
)

func TestShoppingCartItem(t *testing.T) {
	address := fmt.Sprintf("%v:%v@(%v:%v)/%v?charset=utf8mb4,utf8&parseTime=True&loc=Local", "root", "xugang131500", "47.56.16.206", 3306, "shopping_wenke")
	db, err := gorm.Open(mysql.Open(address), &gorm.Config{
		Logger: logger.Default.LogMode(logger.Info),
		NamingStrategy: schema.NamingStrategy{
			SingularTable: true,
		}})
	if err != nil {
		t.Fatal(err)
	}
	repo := repository.NewRepository(db)
	newService := service.NewService(repo, "shoppingservice")
	// ?service.NewService(repo, "shoppingservice")
	t.Run("创建", func(t *testing.T) {
		items := []*pb.ShoppingCartItem{
			{
				ShoppingCartId: 2,
				ProductId:      2,
				Quantity:       2,
				TotalPrice:     8000 * 2,
			},
		}
		err2 := newService.CreateMultipleShoppingCartItem(&pb.CreateShoppingCartItemRequest{
			Items: items,
		})
		// CreateShoppingCart(&pb.CreateShoppingCartRequest{UserId: 1, Quantity: 0})
		fmt.Println(err2)
	})
}
